//-----------------------------------------------------------------------------
#define APPNAME  "tutorial03 - Creating Triangle"
#define APPTITLE "D3D8 tutorial03 - Creating Triangle"

#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };}
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };}

#include <windows.h>
#include <time.h>

#include <d3d8.h>
#pragma comment (lib, "dxguid.lib")
#pragma comment (lib, "d3d8.lib")


//ؽ ü Ÿ 
struct CUSTOMVERTEX { FLOAT x, y, z, rhw; DWORD color; };
#define D3DFVF_CUSTOMVERTEX ( D3DFVF_XYZRHW | D3DFVF_DIFFUSE )


#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };}
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };}


BOOL	g_bActive = TRUE;
HWND	g_hWnd = NULL;

LPDIRECT3D8             g_d3d        = NULL; // our main d3d8 interface
LPDIRECT3DDEVICE8       g_d3d_Device = NULL; // our d3d8 device
LPDIRECT3DVERTEXBUFFER8 g_VertexBuffer = NULL; // our VertexBuffer


bool WindowInit(HINSTANCE hInst, int nCmdShow);
bool AppInit(HINSTANCE hInst, int nCmdShow);
HRESULT InitD3D(HWND hWnd);
bool RenderInit();
void DestroyDirect3D8();
HRESULT ResetDeviceObjects();
HRESULT RenderLoop();
HRESULT Render3D();
void	DestroyDirect3D8();


LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_ACTIVATE:
		g_bActive = LOWORD(wParam);
		break;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
		{
			DestroyDirect3D8();
			DestroyWindow(hWnd);
			PostQuitMessage(0);
		}
		break;

	case WM_CLOSE:          
		DestroyDirect3D8();
        DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;

	case WM_DESTROY:
		PostQuitMessage (0);
		break;
/*  콺 Ŀ ʿ   Ѵ
	case WM_SETCURSOR:
		SetCursor (NULL);
		break; 
*/
	};
	return DefWindowProc(hWnd, message, wParam, lParam);
}
//-----------------------------------------------------------------------------
bool WindowInit(HINSTANCE hInst, int nCmdShow)
{
	WNDCLASS		    wcl;
		
	wcl.hInstance		= hInst;
	wcl.lpszClassName	= APPNAME;
	wcl.lpfnWndProc		= WindowProc;
	wcl.style			= 0;

	wcl.hIcon			= LoadIcon (NULL, IDC_ICON);
	wcl.hCursor			= LoadCursor (NULL, IDC_ARROW);
	wcl.lpszMenuName	= NULL;

	wcl.cbClsExtra		= 0;
	wcl.cbWndExtra		= 0;
	wcl.hbrBackground	= (HBRUSH) GetStockObject (BLACK_BRUSH);

	RegisterClass (&wcl);

	g_hWnd = CreateWindowEx (
		NULL,
		APPNAME,
		APPTITLE,
		WS_OVERLAPPEDWINDOW,
		0, 0, 
		640,
		480,
		NULL,
		NULL,
		hInst,
		NULL);

	if(!g_hWnd) 
		return false;

	return true;
}
//-----------------------------------------------------------------------------
bool AppInit(HINSTANCE hInst, int nCmdShow)
{
	srand (time(0)); // randomize timer

	if(!WindowInit (hInst, nCmdShow)) 
		return false;

	ShowWindow (g_hWnd, nCmdShow);
	UpdateWindow (g_hWnd);
	
	return true;
}
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	g_d3d = Direct3DCreate8 (D3D_SDK_VERSION);
	
	D3DDISPLAYMODE d3ddm;
    g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &d3ddm );

	D3DPRESENT_PARAMETERS d3dpp; 
    ZeroMemory (&d3dpp, sizeof(d3dpp));
    d3dpp.Windowed = true;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = d3ddm.Format;

    g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
						D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &g_d3d_Device);

	return S_OK;
}
//-----------------------------------------------------------------------------
bool RenderInit()
{
	CUSTOMVERTEX g_Vertices[] =
	{
		{  60.0f,  60.0f, 0.5f, 1.0f, 0xffff0000, },
		{ 200.0f,  60.0f, 0.5f, 1.0f, 0xff00ff00, },
		{  60.0f, 200.0f, 0.5f, 1.0f, 0xff0000ff, },

		{  80.0f, 220.0f, 0.5f, 1.0f, 0xff0000ff, },
		{ 220.0f,  80.0f, 0.5f, 1.0f, 0xff00ff00, },
		{ 220.0f, 220.0f, 0.5f, 1.0f, 0xffffff00, },
	};

	g_d3d_Device->CreateVertexBuffer (6*sizeof(CUSTOMVERTEX), 0, D3DFVF_CUSTOMVERTEX, D3DPOOL_DEFAULT, &g_VertexBuffer);
	
	VOID* pVertices;
	g_VertexBuffer->Lock (0, sizeof(g_Vertices), (BYTE**)&pVertices, 0);
    memcpy (pVertices, g_Vertices, sizeof(g_Vertices));
    g_VertexBuffer->Unlock();
	
	return true;
}
//-----------------------------------------------------------------------------
void DestroyDirect3D8 ()
{
	_RELEASE_ (g_VertexBuffer);
	_RELEASE_ (g_d3d_Device);
	_RELEASE_ (g_d3d);
}
//-----------------------------------------------------------------------------
HRESULT RenderLoop()
{
    // Render the scene as normal
	HRESULT hr;
    if( FAILED( hr = Render3D() ) )
        return hr;

	return S_OK;
}
//-----------------------------------------------------------------------------
HRESULT Render3D ()
{
	HRESULT hr;
    g_d3d_Device->Clear (0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB (0, 0, 0), 1.0f, 0);
    g_d3d_Device->BeginScene ();

    g_d3d_Device->SetVertexShader (D3DFVF_CUSTOMVERTEX);
    g_d3d_Device->SetStreamSource (0, g_VertexBuffer, sizeof(CUSTOMVERTEX));
    g_d3d_Device->DrawPrimitive (D3DPT_TRIANGLELIST, 0, 2);

    g_d3d_Device->EndScene ();
    hr = g_d3d_Device->Present (NULL, NULL, NULL, NULL);
	return hr;
}
//-----------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	if(!AppInit(hInst, nCmdShow)) 
		return -1;
	if(InitD3D(g_hWnd)!= S_OK )
		return -1;
	if(!RenderInit())
		return -1;
	
	BOOL bGotMsg;

	msg.message = WM_NULL;
	PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    while( WM_QUIT != msg.message  )
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( g_bActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            //if( 0 == TranslateAccelerator( g_hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            if( g_bActive )
            {
                if( FAILED( RenderLoop()))
                    SendMessage( g_hWnd, WM_CLOSE, 0, 0 );
            }
        }
    }

	UnregisterClass( APPNAME, hInst);
	return 0;
}
//-----------------------------------------------------------------------------